.\" $Id: xtacacsd.man,v 4.0 1996/05/19 17:54:31 vikas Exp vikas $
.TH XTACACSD 8 "Jun 28, 1995"
.SH NAME
xtacacsd \- v4.1 Extended TAC Access Control server for Cisco commServers
.SH SYNOPSIS
.B xtacacsd
.RB [ " \-bdhilnpqs " ]
[
.B -c
.IR configfile
]
[
.B -u
.IR utmpfile
]
[
.B -w
.IR wtmpfile
]
[
.IR password-filename \&. \|. \|.
]
.nf
.RS
\fB \-b \fI (permit Blank passwords fields, useful for anonymous users)
\fB \-d \fI (Debug, repeat for higher debug levels)
\fB \-h \fI (update Host wtmp files also, e.g. wtmp.mycisco)
\fB \-i \fI (Ignore case in usernames for password file matches)
\fB \-l \fI (Log info messages and normal actions via syslog)
\fB \-n \fI (disable use of Domain Nameserver)
\fB \-p \fI (search system Password file in addition to alternate files)
\fB \-q \fI (Quiet mode\-  DENY type responses never sent back)
\fB \-Q \fI (Quiet mode2\-  DENY type responses not sent if user not found)
\fB \-s \fI (Standalone mode\- default is via \fB inetd\fI)
.RE
.ft
.fi
.\" ******************************************************************
.SH DESCRIPTION
.LP
.B xtacacsd
is an 
.I extended
TACACS server (for Cisco network devices)
which authenticates users logging onto a terminal server
(or any host which cares to query the server). It uses the standard
password file 
.RI ( /etc/passwd
) by default, or an alternate list of password files.
.LP
This version of 
.B xtacacsd
has the following \fInew\fR features:
.IP \-
Can create and use DBM format database files for extracting users from
the Unix password files (use Getpw).
.IP \-
Support for the QI/PH name server database from ftp.cso.uiuc.edu
.IP \-
Support for DEC SIA routines and Solaris shadow passwords
.IP \-
support for calling an external password verification program if the password
entry for a user matches a special keyword. This allows support for TokenCard
software such as the Enigma Logic SafeWord system, the Security Dynamics
SecurID card, etc.
.IP \-
allows calling an external program
.I AFTER
the password verification to allow finer control over permitting or denying
a user. The program is run with the username, terminal server and line number
as arguments (can be used to deny access to certain users dialing in on
restricted ports at certain times, etc.)
.IP \-
Case insensitive username matches (the earlier TOLOWER option has been
deleted and replaced with case insensitive searches).
.IP \-
updates and maintain its UTMP file (as well as its WTMP file). The UTMP file
indicates which users are currently logged into all network devices on your
network.
.IP \-
optionally reads a configuration file on startup containing commands to
allow extensive control of responses based on the username, group-id or 
geco string matches. Allows permitting or denying a request based on
its type, originating host and line numbers, and setting access control lists.
.IP \-
Execute a program on the Unix server (not on the client) on getting a 
request from a specified user & host (can be used to initiate dialback)
.IP \-
When run under inetd, it has an inactivity timer of 15 minutes before exiting.
.IP \-
Can send back a SLIP ACL in/out list in tacacs response (need cisco software 
.I v9.21(5.2)
or higher).
.IP \-
Can update a separate WTMP file for each host sending the TACACS query- this
is needed so that the
.I last
program can parse the WTMP sensibly (its back on 'popular' request).
.\"
.LP
Other `standard' tacacs features are:
.IP \-
Can run under
.I inetd
or in standalone mode as a daemon.
.IP \-
can process either the old tacacs queries or the new extended tacacs format 
queries.
.IP \-
can process multiple password files (upto 5 files).
.IP \-
optionally disable the use of nameservers for faster response times or avoid
depending on the nameservers.
.IP \-
optionally not send DENY type responses so that the client can query multiple
tacacs servers.
.\"
.LP
Old features deleted in this version are:
.IP \-
Does not use the gid as the access list number. Now specify the access-list
using the config file.
.IP \-
Does not use the group gid to permit/deny access (defined during compile
time in earlier versions). Now control using the config file.
.IP \-
converting all query names to lowercase has been replaced with case
insensitive username matching.
.\"
.LP
This program can be used to authenticate users when they try to access
a terminal server (
.I cisco 
terminal servers support this option). The server can log information
about all queries coming to the server using 
.B syslog.
It is meant to be invoked by 
.B inetd
but can be run from a terminal in standalone mode if desired. In this mode,
it writes all errors to the controlling terminal.
.LP
The server expects a
.I username
and
.I password
to be supplied in the query packet recieved from the terminal servers. This
username and password are authenticated by searching in the password file(s).
(The default is 
.I /etc/passwd
but upto five alternate filenames can be specified).
If it cannot find a match in any of the password files, it sends an 
.I authentication failure
reply to the query (unless the 
.I quiet
option is specified in which case no negative response will be sent).
.LP
The server always returns an authentication failure for any queries
that have a uid of 0 (
.I root uid
) or for any users that do not have a password (null password field) in
the password files.
It also verifies that the account is current and not expired if the
last password field (
.IR pw_shell)
supports this feature. Finally, permissions are checked for
the request by matching the username, group-id and gecos field of
the user in the tacacs request (the groups listed in the /etc/groups
file are checked as well). The permissions are specified in the
configuration file as described in the CONFIG FILE section below.
.LP
To facilitate user login record keeping, the server writes formatted log
messages at the NOTICE level. The format of these messages is:
.RS
.sp .25
.ps-1
.nf
 STAT:Service:Username:UID:GID @ From-Host:line TTY:TransID:Action:Misc
 STAT:xlogin:vikas:913:10 @ cs500:line tty5:67:accepted:9
.fi
.ps+1
.sp .25
.RE
The TransID is the tacacs transaction ID (which is a unique number per
tacacs query-reply). It is useful for eliminating duplicate entries from
redundant tacacs server logs.
.LP
The entry in the
.I /etc/services
file is:
.RS
.sp .25
.nf
 tacacs		49/udp
.fi
.sp .25
.RE
and in the
.I inetd.conf
file:
.RS
.ps-1
.sp .25
.nf
 tacacs  dgram  udp  wait  root  /etc/xtacacsd  xtacacsd -dlc /etc/xtacacsd-conf
.fi
.ps+1
.sp .25
.RE
.LP
.I NOTE:
When run under
.IR inetd ,
it is strongly advised to list most of the options in the configuration file
and NOT on the command line since there is a limit to the number of arguments
that can be listed in the
.I inetd.conf
file (and it is easy to hit this limit if the utmp and password files etc.
are specified on the tacacs command line).
.\" ******************************************************************
.SH PROTOCOL DESCRIPTION
Extended tacacs on the cisco Communication servers support two types of
configurations- notification and authentication. Authentication requires
a response from the tacacs server to indicate whether the user can 
perform the indicated action. Services that can be authenticated are
login, enable, slipaddr and slipon. In addition,
.I notification
messages
for terminal connections, slipoff and logout can also be sent to the tacacs
server.

.SH Slip Setup
The 'slipaddr' service is essentially a dynamic address selection
on the dialup line. Thus, a remote dialup user who always wants to
get the IP address 192.100.100.11  can dialin and request to be assigned
his 'personal' IP address. Authentication of these requests means that
the user has to supply a password for the IP address desired, and the
tacacs server will check the supplied IP address and password.

To facilitate configuration, it is easier to map the IP address to a
hostname (via DNS) and then let the user supply this hostname instead
of an IP address. Preferably, this hostname will be the same as the
username used for logging in, so only one entry needs to be made in the
password file used by the tacacs server for authenticating.

Alternatively, the terminal server can have static 'default' IP addresses
assigned to the dialup lines and a user can use 'slip default' instead
of requesting an IP address using the slipaddr query.

When a user issues a 'slip default' command, the cisco does
.I not
ask for a username and password. Instead, it sends a SLIPON message to
the tacacs server with the username (which the user had supplied upon
login) in the request. The tacacs server can either permit/deny this
request alongwith a SLIP access-list to be applied. Logins can be forced by
specifying the 'always' keyword in the Cisco configuration.

.SH CHAP & ARAP
CHAP usernames and secrets can be stored as part of the cisco configuration
or alternatively one can configure the commServers to use xtacacs to do the
CHAP and ARAP verification.
The xtacacsd daemon simply creates the ARAP and CHAP responses and sends them
back to the cisco- it does not authenticate the connection by comparing the
challenges with the response, etc. This is done by the cisco CommServer.

These security mechanisms work by the local and remote hosts encrypting the 
same data using the user's password (or "secret"), and then comparing the
.I encrypted
values of the challenge. This avoids having to transmit  the secret in
clear text during the entire handshake.

This version of xtacacsd assumes the user's password field (in the password
file) is the secret (stored in clear text). The password file format is used
for CHAP and ARAP secrets simply for convenience. A simple way to separate
your arap and chap entries is to make sure that you use different usernames
for the regular logins and the chap/arap logins.

Note that the 'secret' has to be stored in cleartext and hence you MUST
protect these files from being readable by anyone except root. Since the
xtacacsd daemon runs as root, you should set the file permissions on the
alternate password files to be 0600.

ARAP requests send an extended tacacs packet with the user name
immediately following the xtacacstype structure and it's length is
specified in the namelen field.  Following that are two ARAP
challenges.  One from the remote client and one from the
commserver.  Both are 8 bytes long and the pwlen value must be 16
bytes.  Both challenge values are DES encrypted using the users
secret and the resulting two values are sent back.  Both response
values are 8 bytes long.  They are appended after the xtacacstype
structure (in the respective order that they were recieved in).
The version field must be the same as one in the received packet.
The namelen must be set to 0 and the pwlen must be set to 16.

CHAP requests come with a user name value with the length specified
in the namelen field.  In the password field there is a single byte
id value followed by a challenge.  The id is from the CHAP message
that the commserver recieved, or is preparing to send.  The
challenge value is a stream of bytes that the commserver recieved
or is preparing to send.  The length of the challenge is pwlen - 1.
(The -1 is for the id byte.)  TACACS must create a new stream of
bytes that looks like:
.RS
.sp .25
.nf
	<id><user secret><challenge>
.fi
.sp .25
.RE
and perform an MD5 hash of that stream.  The return packet must
have the same version number that was received, namelen set to 0,
pwlen set to 16 (the size of an MD5 hash) and the xtacacstype
structure is immediately followed by the MD5 hash.  CHAP requests
may arrive when a remote user is trying to authenticate to the
commserver, or when the commserver has been asked to authenticate
to the remote node.  In the latter case, the username in the
request will be the name of the commserver.

To compile with the ARAP support, you must get the DES libraries
separately. If you are in the United States or Canada, you may get
these files from ftp.cisco.com in the ftp area where you got TACACS.

Alternatively, one can use the
.I arap use-tacacs single-line
or the 
.I chap use-tacacs single-line
cisco configuration commands upon which the user logging in specifies
the username as "<username>*<password>", and the password is always
"arap" (or "chap"). This "sneaks" the username/password pair through in
clear text.  The terminal server notes the "*" in the username, and splits
that into a username/password pair, and then issues a
.I XLOGIN
xtacacs query to the xtacacs server. Note that in this case there will be no
difference between a regular LOGIN request and a ARAP or CHAP request
(however, you dont have to worry about having the passwords in clear text on
your system somewhere).
.\"
.SH SAMPLE SETUP
.IP 1.
Compile the xtacacsd server software. Then:
.RS
.IP -
Edit the /etc/services file and add the port number for tacacs.
.IP -
Edit /etc/inetd.conf and add the line for xtacacsd
.IP -
Edit /etc/syslog.conf and add logging of LOCAL6 messages at debug level
.IP -
Restart or send the HUP signal to your
.IR inetd ,
.I syslogd
processes.
.RE
.IP 2.
Monitor the syslog messages by doing a 'tail -f' on the log file.
.IP 3.
Configure the cisco using the commands:
.RS
.ps-1
.sp .25
.nf
tacacs-server extended
tacacs-server host 192.1.1.1
tacacs-server host 192.1.1.15
tacacs-server last-resort password
!
tacacs-server notify connect
tacacs-server notify slip
tacacs-server notify enable
tacacs-server notify logout
!
! In v11.0 of Cisco software, allow queries to a host using user@host
tacacs-server directed-request
!
tacacs authenticate enable
tacacs authenticate connect
tacacs-server authenticate slip [ always ] [ access-lists ]
!
! In v10.3 of Cisco software, set enable levels
enable use-tacacs
enable last-resort password
!
ppp auth chap
line 1
 login tacacs
 slip address dynamic 202.100.94.101
inter async 1
 ppp use-tacacs [single-line]
 arap use-tacacs [single-line]
 async mode interactive
!
.fi
.ps+1
.sp .25
.RE
.IP 4.
For SLIP/PPP support where you want the user to be able to ask for a
particular IP address, put an entry in your nameserver so that the user
can do a 
.I "slip myusername"
on the cisco and use the same password as he did when logging in. This
is preferred instead of using
.I "slip 192.1.3.4"
for convenience and simplicity in maintaining the password file.
.IP 5.
For CHAP/ARAP support, you can create a separate password file with
the CHAP & ARAP secrets in clear text (yes, the secrets are in clear text if
you are not using the
.I single-line
keyword in the cisco configuration). Make sure that this file is set mode
0600 so that only root can read it.
.LP
The current xtacacsd server implementation always returns an OKAY
response to a 'connect' message, since the same functionality can
be achieved using an ACL applied during login.
.\" ******************************************************************
.SH OPTIONS
.TP
.B \-b
.I (blank passwords)
Normally, the xtacacsd daemon denies all requests where the password field
for the user is blank. However, this option permits blank passwords which
would normally be used for allowing \fIanonymous\fR  FTP users to log in.

Use this option with care and apply careful restrictions via access lists
to prevent undesired breakins.
.TP
.B \-d
.I (debug)
Logs additional debugging information (to
.I syslog
or on the terminal in standalone mode). Extensive debugging information
is obtained by compiling the program with the
.B DEBUG
option.
.TP
.B \-s
.I (standalone)
When the server is run in the standalone mode, it sits in an
endless loop waiting for data to arrive on the TACACS port. If the
debug
.B (\-d)
option is not specified, the program forks and detaches itself from
the controlling terminal. All errors are logged to 
.IR stderr .
.TP
.B \-h
.I (host wtmp files)
With this flag, the xtacacsd daemon will update and maintain a
separate WTMP file for each cisco sending the xtacacs query. It is
useful to use the standard 'last' Unix utility to create accounting
reports. The names of the wtmp files created will have the same
basename as the WTMP file and have the hostname appended to it.
.TP
.B \-i
.I (ignorecase)
This option performs case insensitive username matches in the password file.
It is useful in SLIP queries since the cisco terminal servers convert all
SLIP username queries to uppercase.
.TP
.B \-l
.I (logging)
With this option, the server logs all queries that it serves via
.B syslog
at the INFO level. Without this option, only errors are logged. The logging 
is done at the facility set (LOG_LOCAL6) during compile time.
.TP
.B \-n
.I (no nameserver)
This option disables the use of the nameserver to resolve internet addresses
into names. This speeds up responses in case the nameserver is heavily loaded
or is down.
.TP
.B \-p
.I (system password)
To aid portability, the program searches through the listed alternate
password files assuming that they are text files. If you are running NIS or
shadow passwords, and want to search for users in these files, then specify
this option (or specify DEFAULT as a password filename in the config file).
\fI Note that usernames searched using the DEFAULT keyword will NOT be case
insensitive since it uses the \fRgetpwnam()\fI system call.\fR
.TP
.B \-q
.I (quiet)
So that the server does not send 
.I negative
responses to a query. Thus a client can ask the next tacacs server in its
list in case of a timeout. Note that if a user has accounts on two systems
with tacacs servers, and if the number of logins in being controlled via the
group-id, then the second server might respond even though the maximum number
of allowable logins has been reached on the first tacacs server.
.TP
.B \-Q
.I (Quiet)
Like the -q option except that DENY responses are not sent back only if the
user does not exist in the password files. If the user is found and the
request is denied for some reason, the server will send back a negative
response.
.TP
.BI \-u \ <utmpfile>
specifies an alternate 
.I utmp
file to be searched for the number of allowed logins (can also be set in
the config file).
The default file is defined during compile time (typically
.BR /var/adm/tacacs/utmp ).
The
.B xtacacsd
server deletes entries in the utmp file when a user logs out, and also when
a cisco server reloads (since the server sends out a 
.I xreload 
xtacacs message to the daemon).
However, if the cisco server crashes, then the utmp file could get out
of sync.
.TP
.BI \-w \ <wtmpfile>
Extended tacacs logs the times that a user connects to the terminal server,
logs out or enters
.IR slip .
All queries from all terminal servers are also logged in the same WTMP file.
Standard Unix accounting programs like
.BR ac (8)
can parse and generate reports from this file.
.TP
.B \-c \ <config file>
A config file can be specified with the UTMP filename, the WTMP filename,
the password files and the permissions for each request type. See the
CONFIG FILE section below for the config file syntax.
.TP
.B files
.I <alternate password files>
By default the file
.B /etc/passwd
is used for verifying the username and the password in a tacacs query.
However, upto 5 alternate password files can be specified on the command line
and the server will search in all the files until it finds a match or else
return an error. The alternate password files must be in the 
.B /etc/passwd
format so that the 
.IR getpwent (3)
routines can be used on them. 
.\" ******************************************************************
.SH CONFIGURATION FILE
This version of
.B xtacacsd
supports a configuration file on the command line. The configuration
file can (optionally) list the WTMP, UTMP and the alternate PASSWORD files.
It also lists permissions and corresponding actions for each tacacs
request type.
.LP
The syntax of the config file is:
.RS
.ps-1
.sp .25
.nf
#
# Boolean options
BLANKPASSWORD
NONAMESERVER
IGNORECASE
HOSTWTMP
LOGGING
QUIET

DEBUGLEVEL  2

## If processing a request takes longer than ABORTSECS, the process will
#  exit if this is set. A crude way to flush any pending requests in the
#  system queue. USE ONLY UNDER INETD.
#ABORTSECS  15

# Specify alternate UTMP and the WTMP files (strongly recommended)
WTMP	/var/xtacacs/wtmp
UTMP	/var/xtacacs/utmp

# Upto 5 password files. Command line arguments will precede this list.
# Specify DEFAULT if you are running NIS or shadow passwords and also want to
# search through those files.
PASSWD	DEFAULT
PASSWD	/etc/passwd.local
PASSWD	/usr/local/etc/passwd.xtacacs

##
# For authentication using an external stub program, use the 'AUTHTOKEN' 
# config lines. If the password field in the password file matches the keyword
# (i.e. password-string) specified in this config file, then the corresponding
# external program specified is run with the username and password on the
# command line. This external stub program should return 1 to permit access
# and 0 to deny access.
# Note that this can be any keyword (not limited to enigma or sdi).

#The password string is case sensitive and
# the external program must return 1 to permit access and 0 to deny access.
# 
#       AUTHTOKEN  <passwd-string>  <prog to exec for passwd auth>
AUTHTOKEN 	ENIGMA 	/usr/local/tacacs/bin/enigma 
AUTHTOKEN 	SDI 	/usr/local/tacacs/bin/sdi

## To put restrictions on the connections...
##
#
# While doing an 'exec', it adds on the username, host & line number
# at the end as an argument.
#
# [<list type>] <key> HOST {hostname} [<request type>] [<action>] <args>
#
#	where
#	<list type> is one of:
#		USER GROUP or GECO
#	<request type> is one of:
#		arap chap login connect enable slipaddr slipon all
#	<action> is one of:
#		permit deny norouting acl getok numlogin exec execdeny
#
.fi
.ps+1
.RE
.LP
The list can further be tailored using HOST to specify the terminal
server that is sending the tacacs request and LINE to specify the
tty line number (the LINE's are optional).

Note the syntax of the SLIP access-lists in the SLIP ACL configuration
line - it is
.I <acl in>
.B -
.I <acl out>
(separated by a hyphen). You need the new cisco software versions 
(above 9.21.5) for this functionality.

In following example, the user 'admin' will have an ACL of '0' (no
access-list) and a permit for *all* types of requests. SLIPaddr requests
will have the program 'mail_download' run on the server host.
Users in group 10 will be okay-ed against the program 'daytime_logins'
(which will be run with the username, gid, host & port as args).
This check is done AFTER the password has been verified.
Users in the group 10 will have an inbound slip ACL of 33 and outbound slip 
ACL of 44 applied when they go into slip mode.
Group 10 and users with 'slip' in the gecos field will be permitted 
to go into slip mode. They can also do an 'enable 5' in newer (>10.3) cisco
releases.
User 'bin' is denied all access.
Users with the keyword 'dialback' as the last string in the geco field
will be denied access (execdeny) and the program 'dialback.csh' will be run
(typically a routine to dialout to the remote user's home).
Users with 'slip' as the last string in the geco field will be
permitted access (subject to that fact that no previous line has denied
them access (order is important).
All remaining users will have an ACL of '8' on all connections, and
a limit of 5 on the number of logins.
The last entry is a catch-all so that all other users not listed will be
denied access.
.RS
.sp .25
.ps-1
.nf
##
#   <list> 	  <host [line]> 	 <req> 	 <action> 	<args>
#
USER admin	HOST all 	all	acl		0
USER admin	HOST all	all	permit

USER all 	HOST mycisco  LINE  13,14	login	deny
USER all	HOST all 	all	acl		8
USER all	HOST all  LINE all 	slipaddr execpermit /usr/bin/mail_download

GROUP 10 	HOST noontime 	login 	getok 		/bin/daytime_logins
GROUP 10 	HOST all  LINE 4,5,6,9 	slipon 	acl 		33-44
GROUP 10 	HOST 198.138.178.0 MASK 0.0.0.255 	slipon 	permit
GROUP 10	HOST all	enable level 5	permit

USER bin	HOST all  LINE 1,2,3,4	all	deny

GECO dialback	HOST cs500 	login	execdeny	/bin/dialback.csh
GECO slip	HOST all 	slipon	permit

USER  all	HOST all 	all	numlogin	5	

USER all	HOST all 	all	deny
.fi
.ps+1
.RE
.LP
There are three permission lists:
.IR user ,
.IR group ,
and
.IR gecos .
For the user-list, the 
.B key
is the 
.IR username ,
for the group-list it is the 
.IR gid ,
(NOT group-name, and the /etc/group file is also checked)
and for the geco-list it is a 
.I geco
string match (the last portion of the geco string if it has fields
separated by commas).
.LP
Request types are one of the following:
.TP
.B login
During initial login into the communication server.
.TP
.B connect
If the cisco server is set to authenticate 
.I connect
type requests made by the user.
.TP
.B enable
If the server is set to authenticate
.I enable
type tacacs requests. Note that if you do not define a ENABLE_USER (see
compile time options), then you should use this to control which user
can enable. Users permitted to enable will be able to do so with their
own username and password if ENABLE_USER is not defined.
In cisco releases 10.3 and higher, the user can type
.I enable 12
where 12 is the enable level. Note that an 
.I enable N
line in the config file does not imply that the user can do a enable N-1
i.e. the requested level must match the configured level exactly.
.TP
.B slipon
authentication requests to permit going into SLIP mode. Note that this
is a new feature available in CommServer releases 9.21(5) and higher
only.
.TP
.B slipaddr
authentication requests to allocate the desired IP address for going into
SLIP mode.
.TP
.B all
Any and all tacacs requests.
.\"
.LP
All configuration file entries are processed in the order they are read.
The first permit or deny match will stop any further searches.
Note that ACL entries do not set permit or deny, so put these entries
first in the config file. All other entries set permit or deny explicitly
on matching the key,
and will cause an immediate return without further searches.
.LP
If the 
.IR key ,
.IR hostname
and
.I request_type
match, the specified action is performed. The list of \fIactions\fR are:
.TP
.B permit
Send back a XTACACS_A_ACCEPT response. Stop trying to match any more
permission lines.
.TP
.B deny
Send back a XTACACS_A_REJECT response. Stop trying to match any more
permission lines.
.TP
.B norouting
If the request type is SLIPON and has the ROUTING flag set, send back
a REJECT response. Stops searching for any more matches.
.TP
.B acl
send the access-list number specified in the argument field in the
tacacs response.
.TP
.B numlogin
check the UTMP file for the number of current login's into the
various servers on the network. Set the maximum number of allowed
login's to the value in the argument field. If the number of logins
exceeds the limit, a REJECT response is sent and no more searches 
are done. Otherwise no action is performed.
.TP
.B getok
run the external program specified with the username, group-id, hostname and
dialin port number as command line arguments. If the external program returns
0, access will be denied, else the rest of the lines will be processed until
an explicit permit or deny condition is met. This program is run AFTER the
password authentication. It can be used to deny access to certain users at
specific times of the day, depending on the dialin terminal server and port,
etc.
.TP
.B execpermit
Execute the specified program, while granting access at the same time.
The program specified in the argument field is executed in the background,
with the username, hostname and line number tacked on on the command line.
Stops searching for any more matches.
.TP
.B execdeny
Execute the specified program, while denying access. Similar to the
.I execpermit
option. Can be used to setup dialback for remote users.
Stops searching for any more matches.
.\" ******************************************************************
.SH QI (PH) CSO NAME SERVER SUPPORT
.LP
Support for extracting user information from the PH CSO name server
is available in this version. This software is available from 
.I ftp.cso.uiuc.edu.
The required field-names and the query type has to be set in the ph.c
file during compile time, and the corresponding fields created in the
PH database. Support for extracting CHAP and PAP secrets is not yet
available.
.LP
Note that case insensitive searches cannot be performed in the QI database,
so specify IGNORECASE in xtacacsd and use all lowercase usernames in the
QI database.

Also, most of the fields such as group, uid, shell should be readable
.I without
logging into the server (i.e. these variables should be world readable)
since SLIP queries issued by the xtacacsd daemon do not perform a login.
.LP
If using the QI server, then the following additional configuration options
should be listed in the xtacacsd-config file:
.IP QI_host1
which is the name of the primary CSO server
.IP QI_host2
name of an alternate CSO server
.IP QI_timeout
The read timeout in seconds from the CSO servers
.IP QI_type
If you have specified a particular TYPE for these entries in the database
(e.g. \fI dialup \fR).
.IP QI_uid
The name of the field in the records for extracting the user's UID (used by
xtacacs for all logging, etc.). These are numbers in the range 1 - 65535)
.IP QI_gid
The name of the field in the records for extracting the user's Group ID
(these are supposed to be integers from 0 - 65535). This is used by
xtacacsd for access control
.IP QI_shell
The name of the field for listing the shell- this can be a date string of
the format
.I Aug 11 1996
for listing the expiry date of the account.
.IP QI_gecos
The name of the field for listing the gecos string (any indentifier
string). This is used by xtacacsd for access control (see the description
of how elsewhere in this man page).
.\" *****************************************************************
.SH COMPILE TIME OPTIONS
.LP
The complete list of compile time options are described in the Makefile
and the source code. The most relevant ones (to use) are described here.
.TP
.B UTMP
Location of the
.IR utmp (5)
format file that is updated and maintained by the xtacacsd daemon. This
file lists all the current users on the network. Do
.I not
specify the Unix system-wide
.I /etc/utmp
file\- select a xtacacs specific file instead.
This file is also searched for the number of allowed logins.
.TP
.B WTMP
Location of the
.IR wtmp (5)
format file for maintaining a history of all login/logouts. Do not specify
the system-wide /usr/adm/wtmp file.
.TP
.B ENABLE_USER
If the CommServers are configured to authenticate 'Enable' type requests,
you can either define a specific username using ENABLE_USER, or else
let the user enter his/her own username and password. If ENABLE_USER
is defined, the username+password  that is required during an 'enable'
will be that of the ENABLE_USER.
.TP
.B LOG_FACILITY
The
.IR syslog (3)
logging facility (LOG_LOCAL6 by default).
.\" ******************************************************************
.SH USEFUL TIDBITS
.LP
.IP \-
The
.B utmp
file on Unix systems keeps track of the users
.I currently
logged on the system, as opposed to the
.B wtmp
file which lists all the logins and logouts in the life of the current
file. The length of the username as stored in the wtmp file
is limited to 8 (UT_NAMELEN) in tacutmp.h. This can be increased if desired
\fI however remember to save your previous wtmp files since they will be
incompatible with the new version of the taclast and other tools\fR.
.IP \-
If desired (strongly advised for alternate password file), the alternate
password files can be set to
.I root 
readable only since the server is run as 
.I root
from 
.BR inetd .
.IP \-
.I inetd
cannot handle a large number of command line arguments in the configuration
file. It is strongly advised to list as many options as possible in the
xtacacs configuration file instead of in the inetd.conf file.
.IP \-
How you create alternate password files varies from system to system.
Start by copying over your standard system password file. Then start
looking for ways to manipulate the password in the alternate file (some
systems allow specifying a filename in their
.I passwd
command. Cut and paste also works.
.IP \-
It is advised that the nameserver also run on the same host as xtacacsd
(or on the same LAN) to avoid delays in processing IP address to name
translations.
.IP \-
To use DBM format files for fast access, use the command
\fI Getpw -c password_file_name\fR which will create two files with the
extension
.I .pag
and 
.I .dir
which are used automatically if they exist. Remember to re-create the DBM
files after making any changes to the passwd file.
.IP \-
On SysV based machines, the password age (expiry date) is stored in
the "age" field of the password file. In other systems, the password
expiry is stored in the "shell" field of the password file.
The format of this expiry date is:
.IR "Dec 22 1995" .
.IP \-
System V based machines expect 2 extra fields in their password files after
the GID field- the
.I age
and the
.I comment
field (followed by the gecos, dir and shell).
.RS
.ps-1
.nf
On non-SysV BSD-based machines:
    user : passwd : uid : gid : gecos : dir : shell
On sysV based machines:
    user : passwd : uid : gid : age : comment : gecos : dir : shell
.fi
.ps+1
.RE
.LP
.\" ******************************************************************
.SH XTACACS PROTOCOL LIMITATIONS 
The following are some of the limitations of the xtacacs protocol- these are
NOT a deficiency in the xtacacsd Unix software, but are simply not possible
using the current tacacs protocol.
.IP 1.
Cannot send back a separate IP address than the one that the user asked for.
.IP 2.
Cannot use the cisco
.I autocommand
configuration to specify a command to execute on the cisco when a user logs
into the commServer.
.IP 3.
Does NOT log packets or bytes transferred.
.IP 4.
Cannot use 'autoselect ppp' on the cisco and send queries to tacacs. These
are independent features.
.\" ******************************************************************
.SH TROUBLESHOOTING
Please see the 
.B Protocol Limitations
and the
.B Sample Configuration
sections in this document also.
.IP 1.
The xtacacsd daemon writes detailed log messages via syslog(). Please
compile with -DDEBUG, increase the debug level by specifying multiple
.I \-ddd
options on the command line, add the
.I \-l
option for logging, and make sure that your syslog.conf is set to
log LOCAL6 messages at the DEBUG level.
.LP
Else, comment out the entry in inetd.conf, and run the server in
standalone mode with the
.I \-s
option.
.RS
xtacacsd -dddd -l -s
.RE
.IP 2.
Turn on the debugging on the Cisco commServer using "debug tacacs" and
"terminal monitor".
.IP 3.
Most systems have a limitation on the number of space separated arguments
that you can put in the inetd.conf file. Hence, try to set most of the
xtacacsd options in the xtacacsd-conf  config file and not on the command
line in inetd.conf.
.IP 4.
The "groups" specified in the config file should be group numbers and not
names (i.e. use  '10' instead of 'staff', etc.)
.IP 5.
For SLIP access via xtacacsd, if the user is specifying a hostname to get
an IP address assigned, you must use the IGNORECASE option on the xtacacsd
since the Cisco converts the hostname into all uppercase.
If you use the 'PASSWD DEFAULT' option in the config file, then the
program uses the system's getpw() routines to get the username, and
the ignorecase option will not work on the system passwd files.
However, xtacacsd still tries to convert the query to all lowercase and
search the password file again.
It is preferable to not specify PASSWD DEFAULT and directly list the passwd
file instead. However, if you are using Yellow Pages or shadow passwords,
you will have to use 'PASSWD DEFAULT' or else create a separate password
file.
.IP 6.
If no entry is matched in the permissions listed in the config file, the
default is ALLOW. However, to prevent any unpredictable situations, you
should have an explicit deny or permit wildcard statement as the last
line of the configuration.
.IP 7.
Enable LEVELS are only available in Cisco softare release 10.3 and higher.
.IP 8.
There is a Cisco bug in releases 10.3(4) and lower where notification
messages are not sent to the alternate xtacacsd server (if two or more
servers are listed on the Cisco). In such cases, all wtmp LOGOUT entries
are sent to the primary xtacacs server, whereas the LOGIN entries are
made on the server where the user is authenticated.
If you are using an alternate server, then get the updated Cisco release
software to ensure that your wtmp entries are correct on the main and
the secondary servers.
.\" ******************************************************************
.SH BUGS
Please report new bugs and fixes to vikas@navya.com. Please look in the
.B TROUBLESHOOTING
section of the document also.
.IP 1.
During username searches in the system password files, the program converts
the username to all lowercase (if IGNORECASE is specified) and performs 
a search.
However, a true case insensitive  search is not possible since it uses the
getpwnam()  system call.
.IP 2
Due to vagaries in the utmp.h file on various platforms, your system's
.I last
or
.I ac
utilities might not be able to parse the wtmp and utmp files produced by
this daemon. Use the supplied
.I taclast
program instead, and process the times using awk/perl for accounting.
.IP 3.
The daemon tries to avoid duplicate entries in the UTMP and the WTMP
files, but duplicates/anomalies can show up if a terminal-server was
unreachable or crashed without sending out a 'xreload' message. Would
help to have a tool to periodically query all terminal servers and ensure
that the UTMP file is up to date.
.IP 4.
If there are multiple redundant servers and the primary goes down, the
wtmp & utmp files will get out of sync on the alternate and primary
xtacacs server hosts. In this case, you should use the accompanying
.I tacupd
program to extract the records and merge them into a single file.
.IP 5.
There have been reports of the UID field being inconsistent/wrong in the
logs when a user logs out (this is because the UID is sent by the Cisco and
is not extracted from the password file upon logout, etc.). As such, the line
number and the username should be used for accounting purposes and not the
UID in logout records.
.\" ******************************************************************
.SH FILES
.TP 20
.B /etc/xtacacsd
the main server
.TP 20
.B /etc/xtacacsd-conf
the xtacacsd config file.
.TP 20
.B /etc/passwd
default password file used for authentication
.TP 20
.B /var/adm/tacacs/utmp
file used to check number of allowed logins
.TP 20
.B /var/adm/tacacs/wtmp
file used to record all logins and logouts.
.TP 20
.BR wtmp. "<hostname>"
for host dependent wtmp records.
.\" ******************************************************************
.SH SEE ALSO
.BR taclast (1)
.BR tacupd (1)
.BR Getpw (1)
.BR inetd (8)
.BR inetd.conf (5),
.BR services (5),
.BR syslog (8)
.BR syslog.conf (5)
.LP
.IR "TACACS User Identification Telnet Option"
Brian A. Anderson,
.IR "RFC 927" ,
.IR "RFC 1492"
.\" ******************************************************************
.SH AUTHOR
This enhanced version of the software (with all the features described in this
man page) is written by
.B Vikas Aggarwal
.I (vikas@navya.com)
with contributions by many (See complete details in RELEASE).
Please send all bugs and suggestions to vikas@navya.com.
.LP
Greg Satz (satz@cisco.com), Cisco Systems. Original version, available from
ftp.cisco.com.
.\" ******************************************************************
.SH AVAILABILITY
.LP
Freely available from
.I ftp://ftp.navya.com/pub/vikas/
or from
.IR http://www.netplex-tech.com/software .
